﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using IdeaBlade.Aop;
using IdeaBlade.EntityModel;

namespace TargetInvocationExceptionBis
{
    class Program
    {
        static void Main(string[] args)
        {

            var em = new TargetInvocationExceptionEntities();
            var prof = new Prof();
            em.AddEntity(prof);
            // The line below raise the exception
            var typeinterv = new TypeInterv() { ForProf = true, Taux = 1 };
            em.AddEntity(typeinterv);

            var entities = em.FindEntities<ReferenceBase>(EntityState.AnyAddedModifiedOrDeleted).ToList();

            var em2 = new TargetInvocationExceptionEntities();
            em2.ImportEntities(entities, MergeStrategy.OverwriteChanges);
        }
    }



    [ProvideEntityAspect]
    [DataContract(IsReference = true)]
    public abstract class ReferenceBase
    {
        internal ReferenceBase()
        {
            Actif = true;
        }

        [DataMember]
        [Required]
        public int Id { get; set; }

        [DataMember]
        [Required]
        public bool Actif { get; set; }
    }


    [DataContract(IsReference = true)]
    public class Prof : ReferenceBase
    {
        // No fields
    }

    [DataContract(IsReference = true)]
    public class TypeInterv : ReferenceBase
    {
        [DataMember]
        [Required]
        public bool ForProf { get; set; }

        [DataMember]
        [Required]
        public decimal Taux { get; set; }
    }

    public class TargetInvocationExceptionEntities : EntityManager
    {
        #region Constructors
        public TargetInvocationExceptionEntities(EntityManagerContext context)
            : base(context)
        {
        }

        public TargetInvocationExceptionEntities(EntityManager entityManager, EntityManagerContext entityManagerContext = null)
            : base(entityManager, entityManagerContext)
        {
        }


        public TargetInvocationExceptionEntities(bool shouldConnect = true, string dataSourceExtension = null, EntityServiceOption entityServiceOption = EntityServiceOption.UseDefaultService, string compositionContextName = null)
            : base(shouldConnect, dataSourceExtension, entityServiceOption, compositionContextName)
        {
        }

        public TargetInvocationExceptionEntities(EntityManager entityManager, bool shouldConnect, string dataSourceExtension = null, EntityServiceOption entityServiceOption = EntityServiceOption.UseDefaultService, string compositionContextName = null)
            : base(entityManager, shouldConnect, dataSourceExtension, entityServiceOption, compositionContextName)
        {
        }

        #endregion

        #region EntityQueries

        public EntityQuery<ReferenceBase> RefererencesBase { get; set; }
        public EntityQuery<Prof> Profs { get; set; }
        public EntityQuery<TypeInterv> TypesInterv { get; set; }
        #endregion
    }
}
